package cn.com.infosec.x509.extension;

import cn.com.infosec.asn1.ASN1InputStream;
import cn.com.infosec.asn1.ASN1OctetString;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.x509.AuthorityKeyIdentifier;
import cn.com.infosec.asn1.x509.GeneralName;
import cn.com.infosec.asn1.x509.GeneralNames;
import cn.com.infosec.asn1.x509.SubjectPublicKeyInfo;
import cn.com.infosec.asn1.x509.X509Extensions;
import cn.com.infosec.jce.PrincipalUtil;
import java.math.BigInteger;
import java.security.PublicKey;
import java.security.cert.CertificateParsingException;
import java.security.cert.X509Certificate;

public class AuthorityKeyIdentifierStructure extends AuthorityKeyIdentifier {
   public AuthorityKeyIdentifierStructure(byte[] encodedValue) {
      super((ASN1Sequence)X509ExtensionUtil.fromExtensionValue(encodedValue));
   }

   private static ASN1Sequence fromCertificate(X509Certificate certificate) {
      Exception var10000;
      label119: {
         boolean var10001;
         int var25;
         try {
            var25 = certificate.getVersion();
         } catch (Exception var17) {
            var10000 = var17;
            var10001 = false;
            break label119;
         }

         GeneralName var1;
         SubjectPublicKeyInfo var2;
         SubjectPublicKeyInfo var10002;
         GeneralNames certificate1;
         X509Certificate var10003;
         GeneralNames var10004;
         SubjectPublicKeyInfo var27;
         AuthorityKeyIdentifier var28;
         AuthorityKeyIdentifier var29;
         if (var25 != 3) {
            label121: {
               GeneralName var26;
               try {
                  var26 = new GeneralName;
               } catch (Exception var6) {
                  var10000 = var6;
                  var10001 = false;
                  break label121;
               }

               var1 = var26;

               try {
                  var26.<init>(PrincipalUtil.getIssuerX509Principal(certificate));
                  var27 = new SubjectPublicKeyInfo;
               } catch (Exception var5) {
                  var10000 = var5;
                  var10001 = false;
                  break label121;
               }

               var2 = var27;

               try {
                  var27.<init>((ASN1Sequence)(new ASN1InputStream(certificate.getPublicKey().getEncoded())).readObject());
                  var28 = new AuthorityKeyIdentifier;
                  var29 = var28;
                  var10002 = var2;
                  var10003 = certificate;
                  var10004 = new GeneralNames;
               } catch (Exception var4) {
                  var10000 = var4;
                  var10001 = false;
                  break label121;
               }

               certificate1 = var10004;

               try {
                  var10004.<init>(var1);
                  var29.<init>(var10002, certificate1, var10003.getSerialNumber());
                  return (ASN1Sequence)var28.toASN1Object();
               } catch (Exception var3) {
                  var10000 = var3;
                  var10001 = false;
               }
            }
         } else {
            label122: {
               X509Certificate var32;
               GeneralName var33;
               try {
                  var32 = certificate;
                  var33 = new GeneralName;
               } catch (Exception var16) {
                  var10000 = var16;
                  var10001 = false;
                  break label122;
               }

               var1 = var33;

               byte[] var36;
               try {
                  var33.<init>(PrincipalUtil.getIssuerX509Principal(certificate));
                  var36 = var32.getExtensionValue(X509Extensions.SubjectKeyIdentifier.getId());
               } catch (Exception var15) {
                  var10000 = var15;
                  var10001 = false;
                  break label122;
               }

               byte[] var22 = var36;
               if (var36 != null) {
                  label123: {
                     ASN1OctetString var37;
                     try {
                        var37 = (ASN1OctetString)X509ExtensionUtil.fromExtensionValue(var22);
                     } catch (Exception var11) {
                        var10000 = var11;
                        var10001 = false;
                        break label123;
                     }

                     ASN1OctetString var23 = var37;

                     X509Certificate var30;
                     byte[] var34;
                     try {
                        var28 = new AuthorityKeyIdentifier;
                        var29 = var28;
                        var30 = certificate;
                        var34 = var23.getOctets();
                     } catch (Exception var10) {
                        var10000 = var10;
                        var10001 = false;
                        break label123;
                     }

                     byte[] certificate2 = var34;

                     GeneralNames var35;
                     try {
                        var35 = new GeneralNames;
                     } catch (Exception var9) {
                        var10000 = var9;
                        var10001 = false;
                        break label123;
                     }

                     GeneralNames var24 = var35;

                     BigInteger var31;
                     try {
                        var35.<init>(var1);
                        var31 = var30.getSerialNumber();
                     } catch (Exception var8) {
                        var10000 = var8;
                        var10001 = false;
                        break label123;
                     }

                     BigInteger var21 = var31;

                     try {
                        var29.<init>(certificate2, var24, var21);
                        return (ASN1Sequence)var28.toASN1Object();
                     } catch (Exception var7) {
                        var10000 = var7;
                        var10001 = false;
                     }
                  }
               } else {
                  label124: {
                     try {
                        var27 = new SubjectPublicKeyInfo;
                     } catch (Exception var14) {
                        var10000 = var14;
                        var10001 = false;
                        break label124;
                     }

                     var2 = var27;

                     try {
                        var27.<init>((ASN1Sequence)(new ASN1InputStream(certificate.getPublicKey().getEncoded())).readObject());
                        var28 = new AuthorityKeyIdentifier;
                        var29 = var28;
                        var10002 = var2;
                        var10003 = certificate;
                        var10004 = new GeneralNames;
                     } catch (Exception var13) {
                        var10000 = var13;
                        var10001 = false;
                        break label124;
                     }

                     certificate1 = var10004;

                     try {
                        var10004.<init>(var1);
                        var29.<init>(var10002, certificate1, var10003.getSerialNumber());
                        return (ASN1Sequence)var28.toASN1Object();
                     } catch (Exception var12) {
                        var10000 = var12;
                        var10001 = false;
                     }
                  }
               }
            }
         }
      }

      Exception certificate3 = var10000;
      throw new CertificateParsingException("Exception extracting certificate details: " + certificate3.toString());
   }

   private static ASN1Sequence fromKey(PublicKey param0) {
      // $FF: Couldn't be decompiled
   }

   public AuthorityKeyIdentifierStructure(X509Certificate certificate) {
      super(fromCertificate(certificate));
   }

   public AuthorityKeyIdentifierStructure(PublicKey pubKey) {
      super(fromKey(pubKey));
   }
}
